package com.contextspace.objectdb_example.model.holder;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;

import com.contextspace.objectdb_example.model.AttributeName;
import com.contextspace.objectdb_example.model.IDHolder;
import com.contextspace.objectdb_example.model.OtherObject;

@Entity
public class Holder extends IDHolder implements IHolder {
    
    private AttributeName name = null;
    private List<AttributeName> listOfNames = new ArrayList<AttributeName>();
    private Holder holder = null;
    private Map<AttributeName, List<OtherObject>> mapOfOtherObjects = new HashMap<AttributeName, List<OtherObject>>(); 
    
    /**
     * Default Constructor
     */
    public Holder() {
        
    }
    
    /**
     * @return the name
     */
    @OneToOne(fetch = FetchType.EAGER)
    public AttributeName getName() {
        return name;
    }

    /**
     * @param name the name to set
     */
    public void setName(AttributeName name) {
        this.name = name;
    }

    /**
     * @return the holder
     */
    @OneToOne(cascade=CascadeType.ALL, fetch = FetchType.EAGER)
    public Holder getHolder() {
        return holder;
    }

    /**
     * @param holder the holder to set
     */
    public void setHolder(Holder holder) {
        this.holder = holder;
    }
    
    /**
     * @return the listOfNames
     */
    @OneToMany(fetch = FetchType.EAGER)
    public List<AttributeName> getListOfNames() {
        return listOfNames;
    }

    /**
     * @param listOfNames the listOfNames to set
     */
    public void setListOfNames(List<AttributeName> listOfNames) {
        this.listOfNames = listOfNames;
    }
    
    /**
     * @param newName
     */
    public void addName(AttributeName newName) {
        listOfNames.add(newName);
    }
    
    

    /**
     * @return the mapOfOtherObjects
     */
    //TODO ISSUE WITH THIS
    @OneToMany(fetch = FetchType.EAGER) //, cascade=CascadeType.ALL)
    public Map<AttributeName, List<OtherObject>> getMapOfOtherObjects() {
        return mapOfOtherObjects;
    }

    /**
     * @param mapOfOtherObjects the mapOfOtherObjects to set
     */
    public void setMapOfOtherObjects(
            Map<AttributeName, List<OtherObject>> mapOfOtherObjects) {
        this.mapOfOtherObjects = mapOfOtherObjects;
    }

    /**
     * @param key
     * @param listObjects
     */
    public void addMapEntry(AttributeName key, List<OtherObject> listObjects) {
        mapOfOtherObjects.put(key, listObjects);
    }
    
    /* (non-Javadoc)
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString() {
        StringBuffer buf = new StringBuffer();
        buf.append("<holder");
        if(getId() > 0) {
            buf.append(" id=\"").append(getId()).append("\"");
        }
        buf.append(">");
        buf.append(name);
        if(!listOfNames.isEmpty()) {
            buf.append("<list>");
            for(AttributeName attrName : listOfNames) {
                buf.append(attrName);
            }
            buf.append("</list>");
        }
        if(holder != null) {
            buf.append(holder);
        }
        
        if(mapOfOtherObjects != null && !mapOfOtherObjects.isEmpty()) {
            buf.append("<mapofotherobjects>");
            for(Iterator<AttributeName> i=mapOfOtherObjects.keySet().iterator(); i.hasNext();) {
                AttributeName name = i.next();
                List<OtherObject> listOtherObject = mapOfOtherObjects.get(name);
                buf.append("<item>");
                buf.append("<key>").append(name).append("</key>");
                buf.append("<values>");
                for(OtherObject obj : listOtherObject) {
                    buf.append(obj);
                }
                buf.append("</values>");
                buf.append("</item>");
            }
            buf.append("</mapofotherobjects>");
        }
        
        buf.append("</holder>");
        return buf.toString();
    }

    
    
}
